<?php
/**
 * @category    Pinpoint
 * @package     Pinpoint_Faq
 * @copyright   Copyright (c) 2019 Pinpoint Designs. (http://www.Pinpoint.co.uk)
 * @author      Ahmed Goda <hello@Pinpoint.co.uk>
 */

namespace Pinpoint\Faq\Api\Data;

/**
 * Interface FaqInterface
 */
interface FaqInterface
{
    public const TABLE_NAME           = 'faq';
    public const FAQ_ID               = 'faq_id';
    public const CUSTOMER_NAME        = 'customer_name';
    public const CUSTOMER_EMAIL       = 'customer_email';
    public const QUESTION_TEXT        = 'question_text';
    public const ANSWER_TEXT          = 'answer_text';
    public const IS_ACTIVE            = 'is_active';
    public const IS_CUSTOMER_NOTIFIED = 'is_customer_notified';
    public const PRODUCT_ID           = 'product_id';
    public const CREATED_AT           = 'created_at';
    public const UPDATED_AT           = 'updated_at';
    public const ACTIVE               = 1;
    public const INACTIVE             = 0;
    public const STORE_ID             = 'store_id';

    /**
     * @return int|null
     */
    public function getId();

    /**
     * @return string
     */
    public function getCustomerName(): string;

    /**
     * @param string $customerName
     * @return FaqInterface
     */
    public function setCustomerName(string $customerName): FaqInterface;

    /**
     * @return string
     */
    public function getCustomerEmail(): string;

    /**
     * @param string $customerEmail
     * @return FaqInterface
     */
    public function setCustomerEmail(string $customerEmail): FaqInterface;

    /**
     * @return string
     */
    public function getQuestionText(): string;

    /**
     * @param string $text
     * @return FaqInterface
     */
    public function setQuestionText(string $text): FaqInterface;

    /**
     * @return string
     */
    public function getAnswerText(): string;

    /**
     * @param string $text
     * @return FaqInterface
     */
    public function setAnswerText(string $text): FaqInterface;

     /**
      * @return bool
      */
    public function isActive(): bool;

    /**
     * @return FaqInterface
     */
    public function setActive(): FaqInterface;

    /**
     * @return FaqInterface
     */
    public function setInactive(): FaqInterface;

    /**
     * @return int|null
     */
    public function getProductId();

    /**
     * @return FaqInterface
     */
    public function setProductId(): FaqInterface;

    /**
     * @return string
     */
    public function getCreatedAt(): string;

    /**
     * @param \DateTime $dateTime
     * @return FaqInterface
     */
    public function setCreatedAt(\DateTime $dateTime): FaqInterface;

    /**
     * @return string
     */
    public function getUpdatedAt(): string;

    /**
     * @param \DateTime $dateTime
     * @return FaqInterface
     */
    public function setUpdatedAt(\DateTime $dateTime): FaqInterface;

    /**
     * @return int|null
     */
    public function getStoreId();

    /**
     * @return FaqInterface
     */
    public function setStoreId(): FaqInterface;
}
